<!DOCTYPE html>
<html lang="en">
    <head>
        <title>User Crud Web App</title>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
        <link rel="stylesheet" href="https://cdn.datatables.net/1.10.19/css/jquery.dataTables.min.css">
    </head>
    <body>
        <div class="row">
            <div class="col-sm-4">
                <div class="widget" style="margin-bottom: 32px">
                    <h2>Create user</h2>
                    <form method="post" action="users/create" id="createform">
                        Name: <input type="text" name="name" id="name" placeholder="e.g. John Doe" required><br>
                        Birthday: <input type="text" name="birthday" id="birthday" placeholder="YYYY-MM-DD" required><br>
                        Email addresses: <textarea name="emails" id="emails" rows="3" cols="25" placeholder="e.g. example@example.com" required></textarea><br>
                        <input type="submit" value="Create user">
                    </form>
                    <span id="createresponse"></span>
                </div>
            </div>
            <div class="col-sm-8">
                <div class="widget" style="margin-bottom: 32px">
                    <h2>All users</h2>
                    <table id="userstable">
                        <thead>
                            <tr>
                                <th>name</th>
                                <th>birthday</th>
                                <th>emails</th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        <script src="https://code.jquery.com/jquery-3.3.1.min.js"></script>
        <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.24.0/moment.min.js"></script>
        <script src="https://cdn.datatables.net/1.10.19/js/jquery.dataTables.min.js"></script>
        <script>
            function refresh() {
                $.ajax({
                    url: "users/findall",
                    type: 'GET',
                    dataType: 'json',
                    success: function (data) {
                        $('#userstable').DataTable({
                            destroy: true,
                            data: data,
                            columns: [
                                {
                                    data: "name",
                                    render: function (data, type, row) {
                                        if (type === "display") {
                                            return data;
                                        } else if (type === "sort") {
                                            return data;
                                        } else {
                                            return data;
                                        }
                                    }
                                },
                                {
                                    data: "birthday",
                                    render: function (data, type, row) {
                                        if (type === "display") {
                                            return moment(data).format("MM/DD/YYYY");
                                        } else if (type === "sort") {
                                            return data;
                                        } else {
                                            return data;
                                        }
                                    }
                                },
                                {
                                    data: "emails",
                                    render: function (data, type, row) {
                                        if (type === "display") {
                                            return data;
                                        } else if (type === "sort") {
                                            return data;
                                        } else {
                                            return data;
                                        }
                                    }
                                }
                            ]
                        });
                    },
                    error: function (e) {
                        console.log(e);
                    }
                });
            }
            $("#createform").submit(function (e) {
                e.preventDefault();
                $.ajax({
                    url: "users/create",
                    type: 'POST',
                    dataType: 'json',
                    data: {
                        name: $("#name").val(),
                        birthday: $("#birthday").val(),
                        emails: JSON.stringify($("#emails").val().split(/\n/))
                    },
                    success: function (data) {
                        $('#createresponse').html(data);
                        refresh();
                    },
                    error: function (e) {
                        $('#createresponse').text("Error: " + JSON.parse(e.responseText).message);
                    }
                });
            });
            $(document).ready(function () {
                refresh();
            });
        </script>
    </body>
</html>
